/********************* ROLES **********************/

/********************* UDFS ***********************/

DECLARE EXTERNAL FUNCTION ASCII_VAL
char(1)
RETURNS integer BY VALUE 
ENTRY_POINT 'IB_UDF_ascii_val'
MODULE_NAME 'ib_udf';

DECLARE EXTERNAL FUNCTION STRLEN
cstring(32767)
RETURNS integer BY VALUE 
ENTRY_POINT 'IB_UDF_strlen'
MODULE_NAME 'ib_udf';

/****************** SEQUENCES ********************/

CREATE SEQUENCE GN_ID;
/******************** DOMAINS *********************/

CREATE DOMAIN DOM_APE
 AS varchar(50)
 NOT NULL
 CHECK (STRLEN(value) >= 2)
 COLLATE NONE;
CREATE DOMAIN MON$SEC_DATABASE
 AS char(7) CHARACTER SET ASCII
 NOT NULL
 COLLATE ASCII;
CREATE DOMAIN SEC$KEY
 AS varchar(10) CHARACTER SET UNICODE_FSS
 COLLATE UNICODE_FSS;
CREATE DOMAIN SEC$NAME_PART
 AS varchar(10) CHARACTER SET UNICODE_FSS
 COLLATE UNICODE_FSS;
CREATE DOMAIN SEC$USER_NAME
 AS varchar(10) CHARACTER SET UNICODE_FSS
 COLLATE UNICODE_FSS;
CREATE DOMAIN SEC$VALUE
 AS varchar(85) CHARACTER SET UNICODE_FSS
 COLLATE UNICODE_FSS;
/******************* PROCEDURES ******************/

SET TERM ^ ;
CREATE PROCEDURE P_IT_USODOMINIO (
    PID integer,
    PAPENOM varchar(50) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE P_ST_USODOMINIO (
    IDDESDE integer,
    IDHASTA integer )
RETURNS (
    NRO_DE_FILA integer,
    ID integer,
    APENOM varchar(50) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE SP_TEST
RETURNS (
    ID integer,
    DESCR varchar(50) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

/******************** TABLES **********************/

CREATE TABLE OTROTEST
(
  ID integer NOT NULL,
  DESCR varchar(50) NOT NULL,
  FECHA date,
  MONTO double precision,
  CONSTRAINT INTEG_7 PRIMARY KEY (ID)
);
CREATE TABLE TBL_USER
(
  USERNAME char(20) NOT NULL,
  NAME varchar(50),
  "PASSWORD" varchar(50) NOT NULL,
  CONSTRAINT INTEG_11 PRIMARY KEY (USERNAME)
);
CREATE TABLE TEST
(
  ID integer NOT NULL,
  DESCR varchar(50) NOT NULL,
  FECHA date,
  CONSTRAINT INTEG_4 PRIMARY KEY (ID)
);
CREATE TABLE T_USODOMINIO
(
  ID integer DEFAULT 1 NOT NULL,
  APENOM DOM_APE,
  CONSTRAINT PK_T_USODOMINIO PRIMARY KEY (ID)
);
/********************* VIEWS **********************/

CREATE VIEW V_USODOMINIO (ID, APENOM, IDAPENOM)
AS 
    select ID,APENOM,ID || '-' || APENOM FROM T_USODOMINIO;
/******************* EXCEPTIONS *******************/

/******************** TRIGGERS ********************/

SET TERM ^ ;
CREATE TRIGGER TRG_BIT_USODOMINIO FOR T_USODOMINIO ACTIVE
BEFORE insert POSITION 0
AS 
BEGIN 
    -- INCREMENTO EN 1 A gen_id Y LO GUARDO EN ID
	NEW.ID = gen_id(GN_ID,1); 
END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE P_ABM_TEST (
    OP char(1),
    ID integer,
    DESCR varchar(50) )
RETURNS (
    RET smallint,
    DRET varchar(50) )
AS
BEGIN
  /* write your code here */ 
  RET = 1;DRET = 'OK';
  IF ( OP = 'A' ) THEN INSERT INTO TEST(ID,DESCR) VALUES(:ID,:DESCR);
  IF ( OP = 'B' ) THEN DELETE FROM TEST WHERE ID = :ID;
  IF ( OP = 'C' ) THEN UPDATE TEST SET DESCR = :DESCR WHERE ID = :ID;
  WHEN ANY DO begin
     RET = 0;
     DRET = 'ERROR';
  end
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE P_IT_USODOMINIO (
    PID integer,
    PAPENOM varchar(50) )
AS
BEGIN
   insert into t_usodominio values(:PID,:PAPENOM);
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE P_ST_USODOMINIO (
    IDDESDE integer,
    IDHASTA integer )
RETURNS (
    NRO_DE_FILA integer,
    ID integer,
    APENOM varchar(50) )
AS
BEGIN
   NRO_DE_FILA = 0;
   FOR select ID,APENOM FROM T_USODOMINIO 
       WHERE ID >= :IDDESDE AND ID <= :IDHASTA
       INTO :ID,:APENOM DO begin
           NRO_DE_FILA = NRO_DE_FILA + 1;
           suspend;
   END 
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE SP_TEST
RETURNS (
    ID integer,
    DESCR varchar(50) )
AS
BEGIN
    FOR SELECT 
        a.ID, 
        a.DESCR
    FROM TEST a order BY A.ID
    INTO 
        ID, 
        DESCR 
    DO
    BEGIN
        SUSPEND;
    END
END^
SET TERM ; ^


ALTER TABLE T_USODOMINIO ADD CONSTRAINT CK_T_USODOMINIO_ID
  CHECK (ID > 0);
CREATE INDEX IDX_T_USODOMINIO ON T_USODOMINIO (APENOM);
GRANT EXECUTE
 ON PROCEDURE P_ABM_TEST TO  SYSDBA;

GRANT EXECUTE
 ON PROCEDURE P_IT_USODOMINIO TO  SYSDBA;

GRANT EXECUTE
 ON PROCEDURE P_ST_USODOMINIO TO  SYSDBA;

GRANT EXECUTE
 ON PROCEDURE SP_TEST TO  SYSDBA;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON OTROTEST TO  SYSDBA WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON TBL_USER TO  SYSDBA WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON TEST TO  SYSDBA WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON T_USODOMINIO TO  SYSDBA WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON V_USODOMINIO TO  SYSDBA WITH GRANT OPTION;

