package webapps.ajax1.model;

import java.io.*;
import com.google.gson.*;
import com.google.gson.stream.*;
import com.google.gson.reflect.*;
import java.util.*;
import java.lang.reflect.*;

import webapps.ajax1.entities.*;
/**
 * Serializacion customizada para fechas acorde con
 * el standard de jtable 
 * En JSON "/" and "\/" son equivalentes.
 * 
 * @author G. Cherencio 
 * @see http://jtable.org
 * @see https://stackoverflow.com/questions/10314715/why-is-json-encode-adding-backslashes
 * @version 1.0
 */
public class DateJsonAdapter implements JsonDeserializer, JsonSerializer {
	public Date deserialize(JsonElement json,Type typeOfT,JsonDeserializationContext context) throws JsonParseException {
	    if ( json == null ) return null;
	    String sfecha = json.getAsString();
//TRACE	    
//System.out.println("DateJsonAdapter.deserialize(): sfecha="+sfecha);
        int pos = sfecha.indexOf("(");
        if ( pos == -1 ) return null;
        int pos2 = sfecha.indexOf(")",pos+1);
        if ( pos2 == -1 ) return null;
	    Long l = new Long(sfecha.substring(pos+1,pos2));
		return new Date(l);
	}
	public JsonElement serialize(Object date,Type typeOfSrc,JsonSerializationContext context) {
	    if ( date == null ) return null;
        String sdate = "/Date("+((Date) date).getTime()+")/";
//TRACE        
//System.out.println("DateJsonAdapter.serialize(): sdate="+sdate);
		return new JsonPrimitive(sdate);
	}	
	
	//TEST
	public static void main(String[] arg) {
        GsonBuilder gson = new GsonBuilder();
        gson.registerTypeAdapter(Date.class, new DateJsonAdapter());
        Gson objGson = gson.setPrettyPrinting().create();
        prueba1(objGson);
        prueba2(objGson);
        
	}
	public static void prueba2(Gson objGson) {
	    // prueba con 1 registro
	    System.out.println("************************PRUEBA2****************");
	    Test t = new Test(2211,"prueba2211!");
        JTableData<Test> jtd = new JTableData<Test>("OK",t);
        Type listType = new TypeToken<JTableData<Test>>() {}.getType();
        // Convert Test objects to json
        String json = objGson.toJson(jtd);
        System.out.println("**Convierto arreglo de objetos Test a Json**");
        System.out.println(json);
        
        // Convert to json to Test object
        System.out.println("**Convierto de JSON a Arreglo de objetos Test");
        JTableData<Test> jtd2 = objGson.fromJson(json,listType);
        if ( jtd2.getRecords() != null ) for(Test tt : jtd2.getRecords()) System.out.println(tt);
        if ( jtd2.getRecord() != null )  System.out.println(jtd2.getRecord());
	}
	public static void prueba1(Gson objGson) {
	    // prueba con muchos registros
	    System.out.println("************************PRUEBA1****************");
	    
        List<Test> lst = new ArrayList<Test>();
        lst.add(new Test(1234,"prueba!"));
        lst.add(new Test(4567,"prueba2"));
        JTableData<Test> jtd = new JTableData<Test>("OK",lst);
        Type listType = new TypeToken<JTableData<Test>>() {}.getType();
        // Convert Test objects to json
        String json = objGson.toJson(jtd);
        System.out.println("**Convierto arreglo de objetos Test a Json**");
        System.out.println(json);
        
        // Convert to json to Test object
        System.out.println("**Convierto de JSON a Arreglo de objetos Test");
        JTableData<Test> jtd2 = objGson.fromJson(json,listType);
        if ( jtd2.getRecords() != null ) for(Test t : jtd2.getRecords()) System.out.println(t);
        
        System.out.println("**Convierto arreglo de objetos Test CON ERROR a Json**");
        jtd.setMessage("Error leyendo BD FB");
        String json2 = objGson.toJson(jtd);
        System.out.println(json2);

        System.out.println("**Convierto de JSON CON ERROR a objeto Test**");
        JTableData<Test> jtd3 = objGson.fromJson(json2,listType);
        if ( jtd3.getRecords() != null ) for(Test t : jtd3.getRecords()) System.out.println(t);
        
	}
}
